Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::IndexIDMap2 Struct Reference

`#include <MetaIndexes.h>`

Inheritance diagram for faiss::IndexIDMap2:

## Public Member Functions
| IndexIDMap2 (Index *index)
void | construct_rev_map ()
| make the rev_map from scratch
void | add_with_ids (idx_t n, const float *x, const long *xids) override
long | remove_ids (const IDSelector &sel) override
| remove ids adapted to IndexFlat
void | reconstruct (idx_t key, float *recons) const override
Public Member Functions inherited from faiss::IndexIDMap
| IndexIDMap (Index *index)
void | add (idx_t n, const float *x) override
| this will fail. Use add_with_ids
void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
void | train (idx_t n, const float *x) override
void | reset () override
| removes all elements from the database.
void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const

## Public Attributes
std::unordered_map< idx_t, idx_t > | rev_map
Public Attributes inherited from faiss::IndexIDMap
Index * | index
bool | own_fields
| ! the sub-index
std::vector< long > | id_map
| ! whether pointers are deleted in destructo
Public Attributes inherited from faiss::Index
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Additional Inherited Members
Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Detailed Description

same as IndexIDMap but also provides an efficient reconstruction implementation via a 2-way index

Definition at line 63 of file MetaIndexes.h.

## Member Function Documentation

void faiss::IndexIDMap2::add_with_ids | ( | idx_t | n,
|  | const float * | x,
|  | const long * | xids
| ) |  |
| overridevirtual

Same as add_core, but stores xids instead of sequential ids

Parameters

  xids | if non-null, ids to store for the vectors (size n)

Reimplemented from faiss::IndexIDMap.

Definition at line 142 of file MetaIndexes.cpp.

void faiss::IndexIDMap2::reconstruct | ( | idx_t | key,
|  | float * | recons
| ) |  | const
| overridevirtual

Reconstruct a stored vector (or an approximation if lossy coding)

this function may not be defined for some indexes

Parameters

  key | id of the vector to reconstruct
  recons | reconstucted vector (size d)

Reimplemented from faiss::Index.

Definition at line 168 of file MetaIndexes.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/MetaIndexes.h
- /data/users/matthijs/github_faiss/faiss/MetaIndexes.cpp